/*
 * hamcode ver1.21 (for iOS4)
 * 2010/8/7
 */

var startBoard = "\
--------\
--------\
--------\
---OX---\
---XO---\
--------\
--------\
--------";

var bgColor = "transparent";
var ah18Color = "black";
var textColor = "black";
var movesColor = "yellow";
var scoreColor = "darkkhaki";
var boardColor = "#3CB371";
var trialColor = "#33aaaa";
var dotColor = "#";
var defDotCol = "#196619";
var dotReplay = "#";
var defDotRep = "#1e5938";
var dotTrial = "#";
var defDotTry = "#195555";
var putColor = "magenta";
var frame1Color = "#900000 #300000 #300000 #900000";
var frame2Color = "#600000";
var frame3Color = "#300000 #900000 #900000 #300000";
var strSize = "S";
var putMark = "OFF";
var putNext = "OFF";
var putEnable = "OFF";
var putTrial = "OFF";

var BLACK = -1;
var WHITE = 1;
var EMPTY = 0;
var WALL = 9;
var PASS = -9;
var pos_A1 = 10;
var pos_H8 = 80;
var PUTMARK = "・";

var vectAry = new Array(10,9,8,1,-1,-8,-9,-10);
var vtBoard = new Array(91);
var dfBoard = new Array(64);
var kifuTable = new Array(64);
var trialTable = new Array(64);
var flipStack = new Array(1200);
var nextColor = EMPTY;
var startMoveNo = 1;
var startMoveSv = 1;
var beginMoveNo = 1;
var nextMoveNo = 1;
var nextMoveSv = 1;
var lastMoveNo = 60;
var lastMoveSv = 60;
var blackCount = 0;
var whiteCount = 0;
var dfBlackCount = 0;
var dfWhiteCount = 0;
var fStackP = 0;
var fStackPSv = 0;
var fStartP = 0;
var replayKif = "";
var backupKif = "";
var startColor = EMPTY;
var startMode = "replay";
var currentMode = "replay";
var previousMode = "replay";
var disableFirst = false;
var disablePrev = false;
var disableNext = false;
var disableLast = false;
var disableKifu = false;


String.prototype.trim = function() {
	return this.replace(/^[ \s\n\r\t]+|[ \s\n\r\t]+$/g, '');
}

String.prototype.trimAll = function() {
	return this.replace(/[ \s\n\r\t]+/g, '');
}

function getInitParam()
{
	var strParameter;
	var strParamAry;
	var strParam;
	var paraSep,lineSep;
	
	if (!(strParameter = location.search.substr(1))) {
		return false;
	}

	strParameter = decodeURIComponent(strParameter);
	
	if (strParameter.indexOf("=") != -1) {
		paraSep = "="; lineSep = "&";
	}
	else if (strParameter.indexOf(":") != -1) {
		paraSep = ":"; lineSep = ";";
	}
	else {
		return false;
	}
	
	strParamAry = strParameter.split(lineSep);

	for (var i = 0; i < strParamAry.length; i++) {
		if (!strParamAry[i].length) {
			continue;
		}
		strParam = strParamAry[i].split(paraSep);
		if (!(strParam[1])) {
			continue;
		}

		switch (strParam[0].toLowerCase().trim()) {
		case "start_mode":
			switch (strParam[1].toLowerCase().trimAll()) {
			case "replay":
				startMode = "replay";
				break;
			case "trial":
				startMode = "trial";
				break;
			case "kifu":
				startMode = "kifu";
				break;
			default:
				startMode = "replay";
		 	}
			break;
		case "start_board":
			if (strParam[1].trimAll().length == 64) {
				startBoard = strParam[1].trimAll();
			}
			else if (strParam[1].trimAll().length == 65) {
				startBoard = strParam[1].trimAll().substr(0,64);
				switch (strParam[1].trimAll().substr(64,1)) {
				case "x":
				case "X":
					startColor = BLACK;
			 		break;
				case "o":
				case "O":
					startColor = WHITE;
					break;
				}
			}
			else {
				alert("board parameter error.");
			}
			break;
		case "start_move":
			beginMoveNo = parseInt(strParam[1].toLowerCase().trimAll());
			if (beginMoveNo < 1 || beginMoveNo > 60) {
				alert("Error：start_move");
				beginMoveNo = 1;
			}
			break;
		case "start_color":
			switch (strParam[1].toLowerCase().trimAll()) {
			case "black":
			startColor = BLACK;
				break;
			case "white":
			startColor = WHITE;
				break;
			}
			break;
		case "board_color":
			var strColor = strParam[1].trim();
			if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
				try { 
					document.getElementById("dummy").style.color = strColor;
				}
				catch(e) {
					alert("Error: board_color");
					continue;
				}
				boardColor = strColor;
			}
			else {
				boardColor = "#" + strColor;
				dotReplay = (dotReplay == "#" ? ("#" + calcColorDark(strColor)) : dotReplay);
			}
		 	break;
		case "trial_color":
			var strColor = strParam[1].trim();
			if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
				try { 
					document.getElementById("dummy").style.color = strColor;
				}
				catch(e) {
					alert("Error: trial_color");
					continue;
				}
				trialColor = strColor;
			}
			else {
				trialColor = "#" + strColor;
				dotTrial = (dotTrial == "#" ? ("#" + calcColorDark(strColor)) : dotTrial);
			}
			break;
		case "lastmove_color":
			var strColor = checkColorString(strParam[1].trim());
			if (strColor != null) {
				putColor = strColor;
			}
			else {
				alert("Error: lastmove_mark_color");
				continue;
			}
			break;
		case "replay_dot_color":
			var strColor = checkColorString(strParam[1].trim());
			if (strColor != null) {
				dotReplay = strColor;
			}
			else {
				alert("Error: replay_dot_color");
				continue;
			}
			break;
		case "trial_dot_color":
			var strColor = checkColorString(strParam[1].trim());
			if (strColor != null) {
				dotTrial = strColor;
			}
			else {
				alert("Error: trial_dot_color");
				continue;
			}
			break;
		case "ah18_color":
			var strColor = checkColorString(strParam[1].trim());
			if (strColor != null) {
				ah18Color = strColor;
			}
			else {
				alert("Error: ah18_color");
				continue;
			}
			break;
		case "bgcolor":
			var strColor = checkColorString(strParam[1].trim());
			if (strColor != null) {
				bgColor = strColor;
			}
			else {
				alert("Error: bgcolor");
				continue;
			}
			break;
		case "frame_color":
			strColor = strParam[1].trim();
			if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
				try { 
					document.getElementById("dummy").style.borderColor = strColor;
				}
				catch(e) {
					alert("Error: frame_color");
					continue;
				}
				frame1Color = strColor;
				frame2Color = strColor;
				frame3Color = strColor;
			}
			else {
				var normalCol = "#" + strColor;
				var lightCol	= "#" + calcColorLight(strColor);
				var darkCol 	= "#" + calcColorDark(strColor);
				frame1Color = lightCol + " " + darkCol + " " + darkCol + " " + lightCol;
				frame2Color = normalCol;
				frame3Color = darkCol + " " + lightCol + " " + lightCol + " " + darkCol;
			}
			break;
		case "kifu":
			replayKif = checkKifFormat(strParam[1].trimAll());
			break;
		case "matrix":
			replayKif = convMatrixToKif(strParam[1].trimAll());
			break;
		case "size":
			strSize = strParam[1].trim();
			break;
		default:
			;
		}
	}
	
	dotColor = (dotColor == "#" ? defDotCol : dotColor);
	dotReplay = (dotReplay == "#" ? defDotRep : dotReplay);
	dotTrial = (dotTrial == "#" ? defDotTry : dotTrial);
}

function checkColorString(strColor)
{
	if (!(strColor.length == 6 && strColor.search(/[^0-9a-fA-F]/i) < 0)) {
		try { 
			document.getElementById("dummy").style.color = strColor;
		}
		catch(e) {
			return null;
		}
		return strColor
	}
	return "#" + strColor;
}

function calcColorLight(strColor)
{
	var rCol,gCol,bCol;
	rCol = parseInt(strColor.substr(0,2),16);
	gCol = parseInt(strColor.substr(2,2),16);
	bCol = parseInt(strColor.substr(4,2),16);
	var rStr,gStr,bStr;
	rStr = (parseInt(rCol/2*3) > 255 ? 255 : parseInt(rCol/2*3)).toString(16);
	gStr = (parseInt(gCol/2*3) > 255 ? 255 : parseInt(gCol/2*3)).toString(16);
	bStr = (parseInt(bCol/2*3) > 255 ? 255 : parseInt(bCol/2*3)).toString(16);
	var lightCol = ((rStr.length < 2) ? "0" + rStr : rStr)
							 + ((gStr.length < 2) ? "0" + gStr : gStr)
							 + ((bStr.length < 2) ? "0" + bStr : bStr);

	return String(lightCol);
}

function calcColorDark(strColor)
{
	var rCol,gCol,bCol;
	rCol = parseInt(strColor.substr(0,2),16);
	gCol = parseInt(strColor.substr(2,2),16);
	bCol = parseInt(strColor.substr(4,2),16);
	var rStr,gStr,bStr;
	rStr = (parseInt(rCol/2)).toString(16);
	gStr = (parseInt(gCol/2)).toString(16);
	bStr = (parseInt(bCol/2)).toString(16);
	var darkCol = ((rStr.length < 2) ? "0" + rStr : rStr)
							+ ((gStr.length < 2) ? "0" + gStr : gStr)
							+ ((bStr.length < 2) ? "0" + bStr : bStr);

	return String(darkCol);
}

function initBoardPrint()
{
	var i = 0, ahStr = "abcdefgh", doc = document;
	var strID = "", strChar = "", strLine = "";
	var strText = "", strStone = "", strEval = "";
	var faceColor = "", backColor = "", textColor = "";
	var evalColor = "yellow";
	var strHF = '<div class="ham_face" id="face_';
	var strHB = '<div class="ham_back" id="back_';
	var strHE = '<div class="ham_eval" id="eval_';
	var strHT = '<div class="ham_text" id="text_';

	doc.getElementById("hamlite").style.backgroundColor = bgColor;
	doc.getElementById("frame_2").style.backgroundColor = boardColor;
	doc.getElementById("frame_1").style.borderColor = frame1Color;
	doc.getElementById("frame_2").style.borderColor = frame2Color;
	doc.getElementById("frame_3").style.borderColor = frame3Color;

	dfBlackCount = 0;
	dfWhiteCount = 0;

	for (var y = 0; y < 8; y++) {
		var charXID = doc.getElementById("char_" + ahStr.charAt(y));
		var charYID = doc.getElementById("char_" + String(y+1));
		charXID.style.color = ah18Color;
		charYID.style.color = ah18Color;

		for (var x = 0; x < 8; x++) {
			strID = ahStr.charAt(x) + String(y+1);
			strChar = startBoard.charAt(i++);
			switch (strChar) {
			case "X":
				strStone = "●";
				strText = "";
				strEval = "";
				faceColor = 'black';
				backColor = 'white';
				textColor = 'black';
				evalColor = 'white';
				dfBoard[y*8+x] = BLACK;
				dfBlackCount++;
				break;
			case "x":
				strStone = "●";
				strText = "・";
				strEval = "";
				faceColor = 'black';
				backColor = 'white';
				textColor = 'magenta';
				evalColor = 'white';
				dfBoard[y*8+x] = BLACK;
				dfBlackCount++;
				break;
			case "*":
				strStone = "●";
				strText = "＋";
				strEval = "";
				faceColor = 'black';
				backColor = 'white';
				textColor = 'magenta';
				evalColor = 'white';
				dfBoard[y*8+x] = BLACK;
				dfBlackCount++;
				break;
			case "O":
				strStone = "●";
				strText = "";
				strEval = "";
				faceColor = 'white';
				backColor = 'black';
				textColor = 'white';
				evalColor = 'black';
				dfBoard[y*8+x] = WHITE;
				dfWhiteCount++;
				break;
			case "o":
				strStone = "●";
				strText = "・";
				strEval = "";
				faceColor = 'white';
				backColor = 'black';
				textColor = 'magenta';
				evalColor = 'black';
				dfBoard[y*8+x] = WHITE;
				dfWhiteCount++;
				break;
			case "@":
				strStone = "●";
				strText = "＋";
				strEval = "";
				faceColor = 'white';
				backColor = 'black';
				textColor = 'magenta';
				evalColor = 'black';
				dfBoard[y*8+x] = WHITE;
				dfWhiteCount++;
				break;
			case "-":
				strStone = "";
				strText = "";
				strEval = "";
				faceColor = boardColor;
				backColor = boardColor;
				textColor = boardColor;
				evalColor = 'yellow';
				dfBoard[y*8+x] = EMPTY;
				break;
			case "+":
				strStone = "";
				strText = "・";
				strEval = "";
				faceColor = boardColor;
				backColor = boardColor;
				textColor = '#196619';
				evalColor = 'yellow';
				dfBoard[y*8+x] = EMPTY;
				break;
			default:
				strStone = "";
				strText = strChar;
				strEval = "";
				faceColor = boardColor;
				backColor = boardColor;
				textColor = '#ffff00';
				evalColor = 'yellow';
				dfBoard[y*8+x] = EMPTY;
				break;
			}
			strLine = strHF + strID + '">' + strStone + '</div>'
							+ strHB + strID + '">' + strStone + '</div>'
							+ strHE + strID + '">' + strEval  + '</div>'
							+ strHT + strID + '" '
							+ 'onclick="cellClick(this)" '
							+ 'onmouseover="aimPrint(this)" '
							+ 'onmouseout="aimClear(this)">'
							+ strText + '</div>';

			doc.write(strLine);
			doc.getElementById("face_" + strID).style.color = faceColor;
			doc.getElementById("back_" + strID).style.color = backColor;
			doc.getElementById("text_" + strID).style.color = textColor;
			var evalId = doc.getElementById("eval_" + strID);
			evalId.style.color = evalColor;
		}
	}
	doc.write('<div class="x_corner" id="dot_lu"></div>');
	doc.write('<div class="x_corner" id="dot_ru"></div>');
	doc.write('<div class="x_corner" id="dot_ld"></div>');
	doc.write('<div class="x_corner" id="dot_rd"></div>');
}

function aimPrint(obj)
{
	var nPos = ah18_to_pos(obj.id.slice(-2));
	var nCol = nextColor;
	
	if (currentMode == "trial" && vtBoard[nPos] == EMPTY) {
		obj.style.zIndex = 999;
		obj.style.borderColor = "#FFFFFF";
		if (isPutEnable(nPos,nCol)) {
			obj.style.cursor = "pointer";
		}
		else {
			obj.style.cursor = "default";
		}
	}
}

function aimClear(obj)
{
	if (currentMode == "trial") {
		obj.style.zIndex = 99;
		obj.style.borderColor = "#000000";
		obj.style.cursor = "auto";
	}
}

function cellClick(obj)
{
	if (currentMode != "trial")
		return false;

	var ah18 = obj.id.slice(-2);
	var nPos = ah18_to_pos(ah18);
	var nMove = nextMoveNo - startMoveNo;
	var trialKif = "";
	var nTurn = 0;

	if (!isPutEnable(nPos, nextColor))
		return false;

	if (nMove < replayKif.length / 2) {
		if (ah18 != replayKif.substr(nMove * 2, 2)) {
				trialKif = replayKif.substr(nMove * 2); 
				var len = trialKif.length / 2;
				for (var i = 0; i < len; i++) {
					trialTable[ah18_to_idx(trialKif.substr(i*2,2))] = EMPTY;
				}
				replayKif = replayKif.substr(0, nMove * 2); 
				replayKif = replayKif.concat(ah18);
				lastMoveNo = nextMoveNo;
		}
	}
	else {
		replayKif = replayKif.concat(ah18);
		lastMoveNo = nextMoveNo;
	}

	nTurn = putStonePrint(nPos, nextColor);
	countStone(nextColor, nTurn, 1);
	printScore(blackCount, whiteCount);
	trialTable[pos_to_idx(nPos)] = (nextMoveNo + 10) * nextColor;

	var putMark = document.getElementById("PutMark").checked;
	putMarkErase();
	if (putMark) {
		putMarkPrint(ah18,"・",putColor);
	}

	nextMoveNo++;

	var nCol = checkNextColor(nextColor);
	if (nCol == PASS) {
		nCol = checkNextColor(-nextColor);
		if (nCol == PASS) {
			nextColor = -nextColor;
			printNextColor(EMPTY);
			printNextMove(nextMoveNo, lastMoveNo);
		}
		else {
			pos_Push(PASS);
			nextColor = nCol;
			printNextColor(nextColor);
			printNextMove(nextMoveNo, nextMoveNo);
		}
	}
	else {
			nextColor = nCol;
			printNextColor(nextColor);
			printNextMove(nextMoveNo, nextMoveNo);
	}

	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}
	
	setTimeout("setGrayOutButton()",1);
}

function changeTrialMode()
{
	currentMode = "trial";
	dotColor = dotTrial;
	document.getElementById("frame_2").style.backgroundColor = trialColor;
	nextMoveSv = nextMoveNo;
	startMoveSv = startMoveNo;
	startMoveNo = nextMoveNo;
	lastMoveSv = lastMoveNo;
	lastMoveNo = nextMoveNo - 1;
	fStartP = fStackP;
	backupKif = replayKif;
	replayKif = replayKif.substr(0, (nextMoveNo - startMoveNo) * 2);
	 for (var i = 0; i < 64; i++) {
		trialTable[i] = vtBoard[idx_to_pos(i)];
	}
	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}
}
function returnReplayMode()
{
	var nTurn = 0;

	for ( var i = nextMoveNo; i > startMoveNo; i--) {
		nextColor = -nextColor;
		if ((nTurn = pos_Pop()) == PASS) {
			nTurn = pos_Pop();
			nextColor = -nextColor;
		}
		undoFlips(nTurn, -nextColor, true);
		countStone(nextColor, -nTurn, -1);
		nextMoveNo--;
	}
	
	currentMode = "replay";
	dotColor = dotReplay;
	document.getElementById("frame_2").style.backgroundColor = boardColor;
	document.getElementById("kifu").value = "kifu";
	nextMoveNo = nextMoveSv;
	startMoveNo = startMoveSv;
	lastMoveNo= lastMoveSv;
	fStackP = fStartP;
	fStartP = 0;
	replayKif = backupKif;

	currentBoardPrint();
	printScore(blackCount, whiteCount);
	printNextColor(nextColor);
	printNextMove(nextMoveNo, lastMoveNo);

	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}
}

function currentBoardPrint()
{
	var nPos = 0;
	for (var y = 0; y < 8; y++) {
		for (var x = 0; x < 8; x++) {
			nPos = (y + 1) * 9 + x + 1;
			printStone(nPos, vtBoard[nPos], 0);
		}
	}
}

function printScore(bCount,wCount)
{
	document.getElementById("BlackCount").innerHTML = ((bCount < 10) ? String(bCount)+" " : String(bCount));
	document.getElementById("WhiteCount").innerHTML = ((wCount < 10) ? String(wCount)+" " : String(wCount));
}

function printNextMove(nextMove, lastMove)
{
	if (nextMove > lastMove) {
		document.getElementById("MoveNo").innerHTML = "--";
	}
	else {
		document.getElementById("MoveNo").innerHTML = ((nextMove < 10) ? String(nextMove)+" " : String(nextMove));
	}
}

function printNextColor(nextCol)
{
	switch (nextCol) {
	case BLACK:
		document.getElementById("BlackFrame").style.borderColor = movesColor;
		document.getElementById("WhiteFrame").style.borderColor = scoreColor;
		break;
	case WHITE:
		document.getElementById("BlackFrame").style.borderColor = scoreColor;
		document.getElementById("WhiteFrame").style.borderColor = movesColor;
		break;
	default:
		document.getElementById("BlackFrame").style.borderColor = scoreColor;
		document.getElementById("WhiteFrame").style.borderColor = scoreColor;
	}
}

function checkKifFormat(inputKif)
{
	var inKif = inputKif.toLowerCase();
	var x_AtoH;
	var y_1to8;
	var strKif = "";

	for (var i = 0 ; i < inKif.length; i += 2) {
		x_AtoH = inKif.charAt(i);
		if (x_AtoH >= 'a' && x_AtoH <= 'h') {
			strKif = strKif.concat(x_AtoH);
		}
		else {
			break;
		}
		y_1to8 = inKif.charAt(i+1);
		if (y_1to8 >= '1' && y_1to8 <= '8') {
			strKif = strKif.concat(y_1to8);
		}
		else {
			break;
		}
	}

	return strKif;
}

function convMatrixToKif(inputMatrix)
{
	var inMatrix = inputMatrix.toLowerCase();
	var matrixAry = inMatrix.split("|");
	var sortAry = new Array(64);
	var strMoveNo = "";
	var strKif = "";
	var idx = 0;

	for (var i = 0; i <= 60; i++) {
		sortAry[i] = NaN;
	}

	for (var i = 0; i < matrixAry.length; i++) {
		strMoveNo = matrixAry[i];
		if (!strMoveNo.length) {
			continue;
		}
		if (idx < 64 && strMoveNo.search(/[0-9]/i) != -1) {
			sortAry[parseInt(strMoveNo)] = idx_to_ah18(idx);
		}
		idx++;
	}

	for (var i = 1; i <= 60; i++) {
		if (sortAry[i] != NaN) {
			strKif = strKif.concat(sortAry[i]);
		}
	}

	return strKif;
}

function pos_to_ah18(nPos)
{
	var strAtoH = "abcdefgh";
	var str1to8 = "12345678";
	var strX = strAtoH.charAt(nPos%9-1);
	var strY = str1to8.charAt(Math.floor(nPos/9)-1);
	return strX + strY;
}

function ah18_to_pos(ah18)
{
	var strAH18 = ah18.toLowerCase();
	var strAtoH = "abcdefgh";
	var x = strAtoH.search(strAH18.charAt(0));
	var y = parseInt(strAH18.charAt(1)) - 1;
	return (x+1)+(y+1)*9;
}

function pos_to_idx(nPos)
{
	return (nPos%9-1) + (Math.floor(nPos/9)-1) * 8;
}

function idx_to_pos(nIdx)
{
	return (nIdx%8+1) + (Math.floor(nIdx/8)+1) * 9;
}

function idx_to_ah18(nIdx)
{
	var strAtoH = "abcdefgh";
	var str1to8 = "12345678";
	var strX = strAtoH.charAt(nIdx%8);
	var strY = str1to8.charAt(Math.floor(nIdx)/8);
	return strX + strY;
}

function ah18_to_idx(ah18)
{
	var strAH18 = ah18.toLowerCase();
	var strAtoH = "abcdefgh";
	var x = strAtoH.search(strAH18.charAt(0));
	var y = parseInt(strAH18.charAt(1)) - 1;
	return x+y*8;
}

function printStone(nPos, nCol, nMove)
{
	var strAH18 = pos_to_ah18(nPos);

	switch (nCol) {
	case BLACK:
		document.getElementById("face_"+strAH18).style.color = "black";
		document.getElementById("back_"+strAH18).style.color = "white";
		document.getElementById("eval_"+strAH18).style.color = "white";
		document.getElementById("text_"+strAH18).style.color = "yellow";
		document.getElementById("face_"+strAH18).innerHTML = "●";
		document.getElementById("back_"+strAH18).innerHTML = "●";
		document.getElementById("eval_"+strAH18).innerHTML = ((nMove == 0) ? "" : String(nMove));
		document.getElementById("text_"+strAH18).innerHTML = "";
		break;
	case WHITE:
		document.getElementById("face_"+strAH18).style.color = "white";
		document.getElementById("back_"+strAH18).style.color = "black";
		document.getElementById("eval_"+strAH18).style.color = "black";
		document.getElementById("text_"+strAH18).style.color = "yellow";
		document.getElementById("face_"+strAH18).innerHTML = "●";
		document.getElementById("back_"+strAH18).innerHTML = "●";
		document.getElementById("eval_"+strAH18).innerHTML = ((nMove == 0) ? "" : String(nMove));
		document.getElementById("text_"+strAH18).innerHTML = "";
		break;
	default:
		document.getElementById("face_"+strAH18).innerHTML = "";
		document.getElementById("back_"+strAH18).innerHTML = "";
		document.getElementById("eval_"+strAH18).innerHTML = "";
		document.getElementById("text_"+strAH18).innerHTML = "";
	}
}

function checkKifPutEnable(currentKif, startCol)
{
	var nPos = 0;
	var nCol = startCol;
	var tempKif = currentKif;
	var lastMove = currentKif.length / 2;

	for (i = 0; i < 64; i++)
		kifuTable[i] = dfBoard[i];

	for ( var i = 0; i < lastMove; i++) {
		nPos = ah18_to_pos(currentKif.substr(i * 2, 2));
		if (!putStoneBoard(nPos, nCol)) {
			nCol = -nCol;
			if	(!putStoneBoard(nPos, nCol)) {
				tempKif = currentKif.substr(0,(i + 1) * 2);
				alert("kifu error??");
				break;
			}
		}
		kifuTable[pos_to_idx(nPos)] = (i + 1 + 10) * nCol;
		nCol = -nCol;
	}
	return tempKif;
}

function initStartMove()
{
	if (beginMoveNo <= startMoveNo)
		return;
	
	var nPos = 0, nTurn = 0;

	for (var i = nextMoveNo; i < beginMoveNo - 1; i++) {
		nPos = ah18_to_pos(replayKif.substr((i-startMoveNo) * 2, 2));
		nTurn = putStoneBoard(nPos, nextColor);
		countStone(nextColor, nTurn, 1);
		nPos = ah18_to_pos(replayKif.substr((i-startMoveNo+1) * 2, 2));
		nextColor = checkNextMove(nPos, nextColor);
	}

	nPos = ah18_to_pos(replayKif.substr((i-startMoveNo) * 2, 2));
	nTurn = putStoneBoard(nPos, nextColor);
	
	countStone(nextColor, nTurn, 1);
	nextColor = -nextColor;
	startColor = nextColor;
	nextMoveNo = beginMoveNo;

	currentBoardPrint();
}

function isPutEnable(nPos, nCol)
{
	var nCount = 0, nPosInc = 0, nVect = 0;

	if (vtBoard[nPos] != EMPTY)
		return false;

	for (var i = 0; i < 8; i++) {
		nVect = vectAry[i];
		nPosInc = nPos + nVect;
		nCount = 0;
		while (vtBoard[nPosInc] == -nCol) {
			nPosInc += nVect;
			nCount++;
		}
		if (nCount > 0 && vtBoard[nPosInc] == nCol) {
			return true;
		}
	}

	return false;
}

function putStoneBoard(nPos, nCol)
{
	var nCount = 0, nVect = 0, nPosInc = 0, nTurn = 0;

	if (vtBoard[nPos] != EMPTY)
		return 0;

	for (var i = 0; i < 8; i++) {
		nVect = vectAry[i];
		nPosInc = nPos + nVect;
		nCount = 0;
		while (vtBoard[nPosInc] == -nCol) {
			nPosInc += nVect;
			nCount++;
		}
		if (nCount > 0 && vtBoard[nPosInc] == nCol) {
			nTurn += nCount;
			while (nCount > 0) {
				nPosInc -= nVect;
				vtBoard[nPosInc] = nCol;
				pos_Push(nPosInc);
				nCount--;
			}
		}
	}

	if (nTurn > 0) {
		vtBoard[nPos] = nCol;
		pos_Push(nPos);
		pos_Push(nTurn);
	}

	return nTurn;
}

function putStonePrint(nPos, nCol)
{
	var nTurn;
	
	if ((nTurn = putStoneBoard(nPos, nCol)) == 0) {
		return 0;
	}

	printStone(nPos, nCol, 0);
	var nPeek = fStackP - 3;
	for (var i = 0; i < nTurn; i++) {
		printStone(flipStack[nPeek--], nCol, 0);
	}

	return nTurn;
}

function pos_Push(nPos)
{
	flipStack[fStackP++] = nPos;
}

function pos_Pop()
{
	return flipStack[--fStackP];
}

function countStone(nCol, nTurn, nOwn)
{
	if (nCol == BLACK) {
		blackCount = blackCount + nTurn + nOwn;
		whiteCount = whiteCount - nTurn;
	}
	else {
		blackCount = blackCount - nTurn;
		whiteCount = whiteCount + nTurn + nOwn;
	}
}

function undoFlips(nTurn, nCol, flag)
{
	var nPos = pos_Pop();
	var nPos2 = nPos;

	vtBoard[nPos] = EMPTY;
	if (flag) {
		printStone(nPos, EMPTY);
	}

	while(nTurn-- > 0) {
		nPos = pos_Pop();
		vtBoard[nPos] = nCol;
		if (flag) {
			printStone(nPos, nCol, 0);
		}
	}
	return nPos2;
}

function checkNextMove(nPos, nCol)
{
	var nextCol = -nCol;

	if (!isPutEnable(nPos, nextCol)) {
		nextCol = -nextCol;
		if	(!isPutEnable(nPos, nextCol)) {
			nextCol = EMPTY;
			alert("kifu error!?");
		}
		else {
			pos_Push(PASS);
		}
	}

	return nextCol;
}

function initVirtualBoard()
{
	for (var i = 0; i < 9; i++) {
		vtBoard[i] = WALL;
		vtBoard[(i+1)*9] = WALL;
		vtBoard[i+82] = WALL;
	}
	
	for (var i = 0; i < 64; i++) {
		vtBoard[idx_to_pos(i)] = dfBoard[i];
	}
}

function initBoardStatus()
{
	fStackP = 0;
	startMoveNo = dfBlackCount + dfWhiteCount - 4 + 1;
	nextMoveNo = startMoveNo;
	lastMoveNo = startMoveNo + replayKif.length / 2 - 1;
	if (startColor == EMPTY) {
		if (nextMoveNo % 2) {
			startColor = BLACK;
		}
		else {
			startColor = WHITE;
		}
	}
	nextColor = startColor;
	blackCount = dfBlackCount;
	whiteCount = dfWhiteCount;
	currentMode = startMode;
	currentBrowserName = checkBrowserName();
	currentBrowserType = checkPlatform();
}

function changeStartMode()
{
	switch (startMode) {
	case "trial":
		switchScorePanel("score");
		printScore(blackCount,whiteCount);
		var nCol = checkNextColor(nextColor);
		if (nCol != PASS) {
			printNextMove(nextMoveNo, nextMoveNo);
		}
		else {
			printNextMove(nextMoveNo, lastMoveNo);
		}
		printNextColor(nextColor);
	 	document.getElementById("PutTrial").checked = true;
		changeTrialMode();
		break;
	case "kifu":
		switchScorePanel("kifu");
		changeKifuMode();
		break;
	default: //"replay"
		printScore(blackCount,whiteCount);
		printNextMove(nextMoveNo,lastMoveNo);
		printNextColor(startColor);
	 	dotColor = dotReplay;
		break;
	}

	setGrayOutButton();
}

function changeKifuMode()
{
	currentMode = "kifu";
	if (previousMode == "trial") {
		kifPrint(trialTable);
	}
	else {
		kifPrint(kifuTable);
 }
	switchScorePanel("kifu");
	document.getElementById("KifuText").value = replayKif;
	document.getElementById("kifu").value = "board";
}

function moveFirst()
{
	if (disableFirst)
		return;

	var nTurn = 0;

	for ( var i = nextMoveNo; i > startMoveNo; i--) {
		nextColor = -nextColor;
		if ((nTurn = pos_Pop()) == PASS) {
			nTurn = pos_Pop();
			nextColor = -nextColor;
		}

		undoFlips(nTurn, -nextColor, true);
		countStone(nextColor, -nTurn, -1);
		nextMoveNo--;
	}
	
	currentBoardPrint();
	printScore(blackCount, whiteCount);
	printNextColor(nextColor);
	printNextMove(nextMoveNo, lastMoveNo);
	
	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}

	setTimeout("setGrayOutButton()",1);
}

function movePrev()
{
	if (disablePrev)
		return;
	
	var nTurn=0;

	if (fStackP <= fStartP)
		return;
		
	nextColor = -nextColor;
	if ((nTurn = pos_Pop()) == PASS) {
		nTurn = pos_Pop();
		nextColor = -nextColor;
	}

	undoFlips(nTurn, -nextColor, true);
	countStone(nextColor, -nTurn, -1);
	printScore(blackCount, whiteCount);
	printNextColor(nextColor);
	nextMoveNo--;
	printNextMove(nextMoveNo, lastMoveNo);

	var putMark = document.getElementById("PutMark").checked;
	putMarkErase();
	if (putMark) {
		if (nextMoveNo > startMoveNo) {
			putMarkPrint(replayKif.substr((nextMoveNo - startMoveNo -1)*2, 2),"・",putColor);
		}
	}

	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}

	setTimeout("setGrayOutButton()",1);
}

function moveNext()
{
	if (disableNext || nextMoveNo > lastMoveNo)
		return;

	var ah18 = replayKif.substr((nextMoveNo - startMoveNo)*2, 2);
	var nTurn = putStonePrint(ah18_to_pos(ah18), nextColor);

	countStone(nextColor, nTurn, 1);
	printScore(blackCount, whiteCount);

	var putMark = document.getElementById("PutMark").checked;
	putMarkErase();
	if (putMark) {
		putMarkPrint(ah18,"・",putColor);
	}

	if (nextMoveNo < lastMoveNo) {
		ah18 = replayKif.substr((nextMoveNo - startMoveNo + 1)*2, 2);
		nextColor = checkNextMove(ah18_to_pos(ah18), nextColor);
		printNextColor(nextColor);
	}
	else { //nextMoveNo == lastMoveNo
		nextColor = -nextColor;
		printNextColor(EMPTY);
	}

	nextMoveNo++;
	printNextMove(nextMoveNo, lastMoveNo);
	
	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}
	
	setTimeout("setGrayOutButton()",1);
}

function moveLast()
{
	if (disableLast)
		return;

	var nPos = 0, nTurn = 0;

	for (var i = nextMoveNo; i < lastMoveNo; i++) {
		nPos = ah18_to_pos(replayKif.substr((i-startMoveNo) * 2, 2));
		nTurn = putStoneBoard(nPos, nextColor);
		countStone(nextColor, nTurn, 1);
		nPos = ah18_to_pos(replayKif.substr((i-startMoveNo+1) * 2, 2));
		nextColor = checkNextMove(nPos, nextColor);
	}

	nPos = ah18_to_pos(replayKif.substr((i-startMoveNo) * 2, 2));
	nTurn = putStoneBoard(nPos, nextColor);
	
	countStone(nextColor, nTurn, 1);
	nextColor = -nextColor;
	nextMoveNo = lastMoveNo + 1;

	currentBoardPrint();
	printScore(blackCount, whiteCount);
	printNextColor(EMPTY);
	printNextMove(nextMoveNo, lastMoveNo);

	var putMark = document.getElementById("PutMark").checked;
	putMarkErase();
	if (putMark) {
		putMarkPrint(pos_to_ah18(nPos),"・",putColor);
	}

	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}

	setTimeout("setGrayOutButton()",1);
}

function kifuAndReturn()
{
	switch (currentMode) {
	case "replay":
		previousMode = "replay";
		changeKifuMode();
		break;
	case "trial":
		previousMode = "trial";
		changeKifuMode();
		break;
	case "kifu":
		currentBoardPrint();
		switchScorePanel("score");
		currentMode = previousMode;
		printScore(blackCount, whiteCount);
		printNextColor(nextColor);
		printNextMove(nextMoveNo, lastMoveNo);
		if (currentMode == "replay") {
			document.getElementById("PutTrial").checked = false;
		}
		else {
		 	document.getElementById("PutTrial").checked = true;
			var nCol = checkNextColor(nextColor);
			if (nCol != PASS) {
				printNextMove(nextMoveNo, nextMoveNo);
			}
		}
		document.getElementById("kifu").value = "kifu";
		break;
	default:
		break;
	}
	
	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}
	
	setTimeout("setGrayOutButton()",1);
}

function onPutMark()
{
	var putMark = document.getElementById("PutMark").checked;
	if (putMark && (nextMoveNo - startMoveNo) > 1) {
		putMarkPrint(replayKif.substr((nextMoveNo-startMoveNo-1)*2, 2),"・",putColor);
	}
	else if (replayKif.length > 1) {
		putMarkPrint(replayKif.substr((nextMoveNo-startMoveNo-1)*2, 2),"",putColor);
	}
}

function onPutEnable()
{
	var putEnable = document.getElementById("PutEnable").checked;
	if (putEnable) {
		putEnablePrint(PUTMARK, nextColor);
	}
	else {
		putEnablePrint("", nextColor);
	}
}

function onPutTrial(obj)
{
	if (obj.checked) {
		changeTrialMode();
	}
	else {
		returnReplayMode();
	}
	
	setGrayOutButton();
}

function setGrayOutButton()
{
	if (currentMode == "kifu") {
		disabledButton(true,true,false,true,true);
		return;
	}
	
	if (fStackP <= fStartP) {
		document.getElementById("first").disabled = true;
		document.getElementById("prev").disabled = true;
		disableFirst = true;
		disablePrev = true;
	}
	else {
		document.getElementById("first").disabled = false;
		document.getElementById("prev").disabled = false;
		disableFirst = false;
		disablePrev = false;
	}

	if (nextMoveNo > lastMoveNo) {
		document.getElementById("next").disabled = true;
		document.getElementById("last").disabled = true;
		disableNext = true;
		disableLast = true;
	}
	else	{
		document.getElementById("next").disabled = false;
		document.getElementById("last").disabled = false;
		disableNext = false;
		disableLast = false;
	}
}

function disabledButton(bFirst,bPrev,bKifu,bNext,bLast)
{
	if (bFirst) {
		document.getElementById("first").disabled = true;
		disableFirst = true;
	}
	else {
		document.getElementById("first").disabled = false;
		disableFirst = false;
	}

	if (bPrev) {
		document.getElementById("prev").disabled = true;
		disablePrev = true;
	}
	else {
		document.getElementById("prev").disabled = false;
		disablePrev = false;
	}

	if (bKifu) {
		document.getElementById("kifu").disabled = true;
		disableKifu = true;
	}
	else	{
		document.getElementById("kifu").disabled = false;
		disableKifu = false;
	}

	if (bNext) {
		document.getElementById("next").disabled = true;
		disableNext = true;
	}
	else	{
		document.getElementById("next").disabled = false;
		disableNext = false;
	}

	if (bLast) {
		document.getElementById("last").disabled = true;
		disableLast = true;
	}
	else	{
		document.getElementById("last").disabled = false;
		disableLast = false;
	}
}

function kifPrint(kifuTbl)
{
	var nCol, nMove;
	
	for (var i = 0; i < 64; i++) {
		if (kifuTbl[i] < -10) {
			nCol = BLACK;
			nMove = -kifuTbl[i] - 10;
		}
		else if (kifuTbl[i] > 10) {
			nCol = WHITE;
			nMove = kifuTbl[i] - 10;
		}
		else {
			nCol = kifuTbl[i];
			nMove = 0;
		}
		printStone(idx_to_pos(i), nCol, nMove);
	}
}

function putMarkPrint(strAH18,strChar,strCol)
{ 
	document.getElementById("text_"+strAH18).style.color = strCol;
	document.getElementById("text_"+strAH18).innerHTML = strChar;
}

function putMarkErase()
{
	var nPos = 0;
	var strAH18 = "";

	for (nPos = pos_A1; nPos <= pos_H8; nPos++) {
		if(vtBoard[nPos] == EMPTY || vtBoard[nPos] == WALL) continue;
		strAH18 = pos_to_ah18(nPos);
		if (document.getElementById("text_"+strAH18).innerHTML != "") {
				putMarkPrint(strAH18,"",dotColor);
		}
	}
}

function putEnablePrint(strChar, nCol)
{
	var nPos = 0, bPass = true;
	var strAH18 = "";

	for (nPos = pos_A1; nPos <= pos_H8; nPos++) {
		strAH18 = pos_to_ah18(nPos);
		if(vtBoard[nPos] != EMPTY) continue;
		if(isPutEnable(nPos,nCol)) {
			bPass = false;
			putMarkPrint(strAH18,strChar,dotColor);
		}
		else if (document.getElementById("text_"+strAH18).innerHTML == "・") {
				putMarkPrint(strAH18,"",dotColor);
		}
	}

	if (bPass) {
		for (nPos = pos_A1; nPos <= pos_H8; nPos++) {
			strAH18 = pos_to_ah18(nPos);
			if(vtBoard[nPos] != EMPTY) continue;
			if(isPutEnable(nPos,-nCol)) {
				putMarkPrint(strAH18,strChar,dotColor);
			}
		}
	}
}

function checkNextColor(nCol)
{
	var nPos = 0;

	for (nPos = pos_A1; nPos <= pos_H8; nPos++) {
		if(vtBoard[nPos] != EMPTY)
			continue;
		if(isPutEnable(nPos,-nCol)) {
			return -nCol;
		}
	}
	
	return PASS;
}

function inputKifString()
{
	if (currentMode == "kifu") {
		var inputKif = document.getElementById("KifuText").value;
		inputKif = inputKif.toLowerCase().trimAll();
		if (!(inputKif==null)) {
			for (var i = 0; i < 64; i++) {
				dfBoard[i] = EMPTY;
			}
			dfBoard[ah18_to_idx("d4")] = WHITE;
			dfBoard[ah18_to_idx("e4")] = BLACK;
			dfBoard[ah18_to_idx("d5")] = BLACK;
			dfBoard[ah18_to_idx("e5")] = WHITE;
			dfBlackCount = 2;
			dfWhiteCount = 2;
			startColor = BLACK;
			initVirtualBoard();
			initBoardStatus();
			replayKif = checkKifPutEnable(inputKif, nextColor);
			document.getElementById("KifuText").select();
			kifPrint(kifuTable);
			initVirtualBoard();
			initBoardStatus();
			currentMode = "kifu";
			nextMoveSv = nextMoveNo;
			startMoveSv = startMoveNo;
			lastMoveSv = lastMoveNo;
			backupKif = replayKif;
		}
	}
}

function switchScorePanel(strMode)
{
	var strHTML = "";
	
	switch (strMode) {
	case "score" :
		strHTML = '<div id="BlackFrame"><span id="BlackStone">●</span><span id="BlackCount"></span></div>'
						+ '<div id="WhiteFrame"><span id="WhiteStone">●</span><span id="WhiteCount"></span></div>'
						+ '<div id="NextMove">Next<span id="MoveNo">--</span></div>'
						+ '<div id="TrialMode"><input type="checkbox" id="PutTrial" onClick="onPutTrial(this)" /><span id="PutCheck">Put</span></div>';
		break;
	case "kifu" :
		strHTML = '<input type="text" id="KifuText" onClick="this.select();" onchange="setButtonOn();" onPaste="setButtonOn();" />'
						+ '<input type="button" value="SET" id="SetKifu" onClick="inputKifString();" disabled="true" />';
		break;
	default:
		alert("error: switchScorePanel()");
	}

	document.getElementById("score_panel").innerHTML = strHTML;
}

function setButtonOn()
{
	document.getElementById("SetKifu").disabled = false;
}

function initBtnChkOnOff()
{
	disabledButton(false,false,false,false,false);
 	document.getElementById("PutTrial").checked = (putTrial == "ON" ? true : false);
 	document.getElementById("PutMark").checked = (putMark == "ON" ? true : false);
 	document.getElementById("PutEnable").checked = (putEnable == "ON" ? true : false);
}

function selectCSS()
{
 	var tagString = document.createElement('link');
	tagString.rel = 'stylesheet';
	tagString.type = 'text/css';
	
	switch (strSize.toUpperCase()) {
		case "SS":
			tagString.href = "hamsizeSS.css";
			break;
		case "S":
			tagString.href = "hamsize_S.css";
			break;
		case "M":
			tagString.href = "hamsize_M.css";
			break;
		case "L":
			tagString.href = "hamsize_L.css";
			break;
		case "XL":
			tagString.href = "hamsizeXL.css";
			break;
		case "EL":
			tagString.href = "hamsizeEL.css";
			break;
		default  :
			tagString.href = "hamsize_S.css";
	}

	document.body.appendChild(tagString);
}

function appendJS()
{
 	var tagString = document.createElement('script');
	tagString.type = "text/javascript";

	switch (checkPlatform()) {
	case "LINUX":
		switch (checkBrowserName()) {
			case "FIREFOX":
			case "OPERA":
				tagString.src="forlinux.js";
				document.body.appendChild(tagString);
				break;
			default:
				linux_browser();
		}
		break;
	case "IPHONE":
		iPhone_browser();
		break;
	case "MACOSX":
		switch (checkBrowserName()) {
			case "FIREFOX":
			case "OPERA":
				tagString.src="formacosx.js";
				document.body.appendChild(tagString);
				break;
			default:
				macosx_browser();
		}
		break;
	case "WINDOWS":
		switch (checkBrowserName()) {
			case "MSIE6":
				ie6_browser();
				break;
			case "MSIE7":
				document.write('<style type="text/css">');
				document.write('#op_button { padding-top:1px; }');
				document.write('</style>');
				break;
			default:
				;
		}
		break;
	default:
		;	
	}
}

function checkPlatform()
{
	var webBrowser = navigator.userAgent;
	var platform = "OTHER";

	if (webBrowser.match(/iPhone/i) || webBrowser.match(/iPod/i)) {
		platform = "IPHONE";
	}
	else if (webBrowser.match(/Windows/i)) {
		platform = "WINDOWS";
	}
	else if (webBrowser.match(/Linux/i)) {
		platform = "LINUX";
	}
	 else if (webBrowser.match(/Mac OS X/i)) {
		platform = "MACOSX";
	}

	return platform;
}

function checkBrowserName()
{
	var webBrowser = navigator.userAgent;
	var browserName = "OTHER";

	if (webBrowser.match(/iPhone/i) || webBrowser.match(/iPod/i)) {
		browserName = "IPHONE";
	}
	else if (webBrowser.match(/MSIE [6].[0-9]/i)) {
		browserName = "MSIE6";
	}
	else if (webBrowser.match(/MSIE [7].[0-9]/i)) {
		browserName = "MSIE7";
	}
	 else if (webBrowser.match(/MSIE [8-9].[0-9]/i)) {
		browserName = "MSIE8";
	}
	else if (webBrowser.match(/Opera/i)) {
		browserName = "OPERA";
	}
	else if (webBrowser.match(/Firefox/i)) {
		browserName = "FIREFOX";
	}
	else if (webBrowser.match(/Chrome/i)) {
		browserName = "CHROME";
	}
	else if (webBrowser.match(/Safari/i)) {
		browserName = "SAFARI";
	}

	return browserName;
}

function ie6_browser()
{
	document.write('<style type="text/css">');
		switch (strSize.toUpperCase()) {
			case "SS":
				document.write('.ham_face { line-height:18px; }');
				document.write('.ham_back { line-height:18px; }');
				break;
			case "S":
				document.write('.ham_face { line-height:20px; }');
				document.write('.ham_back { line-height:20px; }');
				break;
			case "M":
				document.write('.ham_face { line-height:22px; }');
				document.write('.ham_back { line-height:22px; }');
				break;
			case "L":
				document.write('.ham_face { line-height:28px; }');
				document.write('.ham_back { line-height:28px; }');
				break;
			case "XL":
				document.write('.ham_face { line-height:32px; }');
				document.write('.ham_back { line-height:32px; }');
				break;
			case "EL":
				document.write('.ham_face { line-height:38px; }');
				document.write('.ham_back { line-height:38px; }');
				break;
			default:
				document.write('.ham_face { line-height:20px; }');
				document.write('.ham_back { line-height:20px; }');
		}
		document.write('#op_button { padding-top:1px; }');
		document.write('.x_corner { overflow:hidden; }');
		document.write('</style>');
}

function linux_browser()
{
	switch (checkBrowserName()) {
	case "CHROME":
		document.write('<style type="text/css">');
		switch (strSize.toUpperCase()) {
			case "SS":
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:15px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:15px; }');
				document.write('.ham_eval { font-size:8px; line-height:11px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:13px; }');
				document.write('.y_char { font-size:13px; }');
				document.write('#score_panel { font-size:13px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:5px; left:73px; }');
				document.write('#PutTrial { top:5px; left:122px; }');
				document.write('#PutCheck { top:3px; left:135px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#BlackFrame { line-height:15px; }');
				document.write('#WhiteFrame { line-height:15px; }');
				break;
			case "S":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_eval { font-size:9px; line-height:12px; padding: 4px 0px 0px 1px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#score_panel { font-size:14px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:5px; left:135px; }');
				document.write('#PutCheck { top:3px; }');
				document.write('#KifuText { font-size:14px; }');
				document.write('#BlackFrame { line-height:15px; }');
				document.write('#WhiteFrame { line-height:15px; }');
				break;
			case "M":
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:18px; }');
				document.write('.ham_eval { font-size:11px; line-height:13px; padding: 5px 0px 0px 2px; }');
				document.write('.x_char { font-size:15px; }');
				document.write('.y_char { font-size:15px; }');
				document.write('#score_panel { font-size:15px; }');
				document.write('#y-coordinate { margin-top:5px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:6px; left:154px; }');
				document.write('#PutCheck { top:5px; }');
				document.write('#KifuText { font-size:15px; }');
				document.write('#BlackFrame { line-height:17px; }');
				document.write('#WhiteFrame { line-height:17px; }');
				break;
			case "L":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:24px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:24px; }');
				document.write('.ham_eval { font-size:13px; line-height:15px; padding: 6px 0px 0px 2px; }');
				document.write('.x_char { font-size:17px; }');
				document.write('.y_char { font-size:17px; }');
				document.write('#score_panel { font-size:16px; }');
				document.write('#y-coordinate { margin-top:6px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:7px; left:172px; }');
				document.write('#PutCheck { top:4px; }');
				document.write('#KifuText { font-size:16px; }');
				document.write('#BlackFrame { line-height:18px; }');
				document.write('#WhiteFrame { line-height:18px; }');
				break;
			case "XL":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:26px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:26px; }');
				document.write('.ham_eval { font-size:15px; line-height:17px; padding: 6px 0px 0px 6px; }');
				document.write('.x_char { font-size:19px; }');
				document.write('.y_char { font-size:19px; }');
				document.write('#score_panel { font-size:18px; }');
				document.write('#y-coordinate { margin-top:11px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:7px; left:204px; }');
				document.write('#PutCheck { top:5px; }');
				document.write('#KifuText { font-size:17px; }');
				document.write('#BlackFrame { line-height:20px; }');
				document.write('#WhiteFrame { line-height:20px; }');
				break;
			case "EL":
				document.write('.ham_face { padding: 0px 0px 0px 1px; line-height:32px; }');
				document.write('.ham_back { padding: 1px 0px 0px 1px; line-height:32px; }');
				document.write('.ham_eval { font-size:16px; line-height:20px; padding: 7px 0px 0px 8px; }');
				document.write('.x_char { font-size:20px; }');
				document.write('.y_char { font-size:20px; }');
				document.write('#score_panel { font-size:20px; }');
				document.write('#y-coordinate { margin-top:13px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:8px; left:239px; }');
				document.write('#PutCheck { top:4px; }');
				document.write('#KifuText { font-size:17px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				break;
			default:
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_eval { font-size:9px; line-height:12px; padding: 4px 0px 0px 1px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#score_panel { font-size:14px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutCheck { top:3px; }');
				document.write('#KifuText { font-size:14px; }');
				document.write('#BlackFrame { line-height:15px; }');
				document.write('#WhiteFrame { line-height:15px; }');
		}
		document.write('</style>');
		break;
	default:
		;
	}
}

function macosx_browser()
{
	switch (checkBrowserName()) {
	case "SAFARI":
		document.write('<style type="text/css">');
		switch (strSize.toUpperCase()) {
			case "SS":
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:16px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:16px; }');
				document.write('.ham_eval { font-size:8px; line-height:12px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#BlackFrame { line-height:16px; }');
				document.write('#WhiteFrame { line-height:16px; }');
				document.write('#score_panel { font-size:12px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:6px; }');
				document.write('#PutTrial { top:5px; left: 122px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { font-size:8px; top:5px; }');
				document.write('#first { font-size:10px; }');
				document.write('#prev  { font-size:10px; }');
				document.write('#kifu  { font-size:10px; }');
				document.write('#next  { font-size:10px; }');
				document.write('#last  { font-size:10px; }');
				break;
			case "S":
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:18px; }');
				document.write('.ham_eval { font-size:9px; line-height:13px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#BlackFrame { line-height:18px; }');
				document.write('#WhiteFrame { line-height:18px; }');
				document.write('#score_panel { font-size:13px; }');
				document.write('#y-coordinate { margin-top:3px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:5px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { font-size:9px; top:5px; }');
				document.write('#first { font-size:11px; }');
				document.write('#prev  { font-size:11px; }');
				document.write('#kifu  { font-size:11px; }');
				document.write('#next  { font-size:11px; }');
				document.write('#last  { font-size:11px; }');
				break;
			case "M":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:19px; line-height:19px; }');
				document.write('.ham_back { font-size:19px; line-height:19px; }');
				document.write('.ham_eval { font-size:10px; line-height:14px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:15px; }');
				document.write('.y_char { font-size:15px; }');
				document.write('#BlackFrame { line-height:19px; }');
				document.write('#WhiteFrame { line-height:19px; }');
				document.write('#score_panel { font-size:14px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#KifuText { font-size:14px; }');
				document.write('#SetKifu { font-size:10px; top:5px; }');
				document.write('#first { font-size:12px; }');
				document.write('#prev  { font-size:12px; }');
				document.write('#kifu  { font-size:12px; }');
				document.write('#next  { font-size:12px; }');
				document.write('#last  { font-size:12px; }');
				break;
			case "L":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:23px; line-height:23px; }');
				document.write('.ham_back { font-size:23px; line-height:23px; }');
				document.write('.ham_eval { font-size:12px; line-height:15px; padding: 6px 0px 0px 3px; }');
				document.write('.x_char { font-size:17px; }');
				document.write('.y_char { font-size:17px; }');
				document.write('#BlackFrame { line-height:20px; }');
				document.write('#WhiteFrame { line-height:20px; }');
				document.write('#score_panel { font-size:16px; }');
				document.write('#y-coordinate { margin-top:5px; }');
				document.write('#KifuText { font-size:15px; }');
				document.write('#SetKifu { font-size:11px; top:4px; }');
				document.write('#first { font-size:13px; }');
				document.write('#prev  { font-size:13px; }');
				document.write('#kifu  { font-size:14px; }');
				document.write('#next  { font-size:13px; }');
				document.write('#last  { font-size:13px; }');
				break;
			case "XL":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:27px; line-height:27px; }');
				document.write('.ham_back { font-size:27px; line-height:27px; }');
				document.write('.ham_eval { font-size:14px; line-height:19px; padding: 6px 0px 0px 6px; }');
				document.write('.x_char { font-size:19px; }');
				document.write('.y_char { font-size:19px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				document.write('#score_panel { font-size:18px; }');
				document.write('#y-coordinate { margin-top:9px; }');
				document.write('#KifuText { font-size:16px; }');
				document.write('#SetKifu { font-size:12px; top:5px; }');
				document.write('#first { font-size:15px; }');
				document.write('#prev  { font-size:15px; }');
				document.write('#kifu  { font-size:15px; }');
				document.write('#next  { font-size:15px; }');
				document.write('#last  { font-size:15px; }');
				break;
			case "EL":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:32px; line-height:32px; }');
				document.write('.ham_back { font-size:32px; line-height:32px; }');
				document.write('.ham_eval { font-size:15px; line-height:22px; padding: 7px 0px 0px 8px; }');
				document.write('.x_char { font-size:20px; }');
				document.write('.y_char { font-size:20px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				document.write('#score_panel { font-size:20px; }');
				document.write('#y-coordinate { margin-top:11px; }');
				document.write('#PutTrial { top:8px; }');
				document.write('#KifuText { font-size:17px; }');
				document.write('#SetKifu { font-size:13px; top:5px; }');
				document.write('#first { font-size:17px; }');
				document.write('#prev  { font-size:17px; }');
				document.write('#kifu  { font-size:17px; }');
				document.write('#next  { font-size:17px; }');
				document.write('#last  { font-size:17px; }');
				break;
			default:
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:18px; }');
				document.write('.ham_eval { font-size:9px; line-height:13px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#BlackFrame { line-height:18px; }');
				document.write('#WhiteFrame { line-height:18px; }');
				document.write('#score_panel { font-size:13px; }');
				document.write('#y-coordinate { margin-top:3px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:5px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { font-size:9px; top:5px; }');
				document.write('#first { font-size:11px; }');
				document.write('#prev  { font-size:11px; }');
				document.write('#kifu  { font-size:11px; }');
				document.write('#next  { font-size:11px; }');
				document.write('#last  { font-size:11px; }');
		}
		document.write('</style>');
		break;
	case "CHROME":
		document.write('<style type="text/css">');
		switch (strSize.toUpperCase()) {
			case "SS":
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:16px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:16px; }');
				document.write('.ham_eval { font-size:6px; line-height:12px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:13px; }');
				document.write('.y_char { font-size:13px; }');
				document.write('#score_panel { font-size:12px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:6px; left:73px; }');
				document.write('#PutTrial { top:6px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { top:3px; }');
				document.write('#BlackFrame { line-height:17px; }');
				document.write('#WhiteFrame { line-height:17px; }');
				break;
			case "S":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_eval { font-size:9px; line-height:14px; padding: 4px 0px 0px 1px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#score_panel { font-size:14px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { left:79px; }');
				document.write('#PutTrial { top:7px; }');
				document.write('#KifuText { font-size:14px; }');
				document.write('#SetKifu { top:3px; }');
				document.write('#BlackFrame { line-height:17px; }');
				document.write('#WhiteFrame { line-height:17px; }');
				break;
			case "M":
				document.write('.ham_face { padding: 1px 0px 0px 2px; line-height:20px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; line-height:20px; }');
				document.write('.ham_eval { font-size:11px; line-height:14px; padding: 5px 0px 0px 2px; }');
				document.write('.x_char { font-size:15px; }');
				document.write('.y_char { font-size:15px; }');
				document.write('#score_panel { font-size:15px; }');
				document.write('#y-coordinate { margin-top:5px; }');
				document.write('#NextMove { left:90px; }');
				document.write('#PutTrial { top:8px; }');
				document.write('#KifuText { font-size:15px; }');
				document.write('#SetKifu { top:4px; }');
				document.write('#BlackFrame { line-height:18px; }');
				document.write('#WhiteFrame { line-height:18px; }');
				break;
			case "L":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:23px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:23px; }');
				document.write('.ham_eval { font-size:13px; line-height:15px; padding: 6px 0px 0px 2px; }');
				document.write('.x_char { font-size:17px; }');
				document.write('.y_char { font-size:17px; }');
				document.write('#score_panel { font-size:16px; }');
				document.write('#y-coordinate { margin-top:6px; }');
				document.write('#NextMove { top:6px; }');
				document.write('#PutTrial { left:172px; }');
				document.write('#PutCheck { top:5px; }');
				document.write('#KifuText { font-size:16px; }');
				document.write('#SetKifu { top:4px; }');
				document.write('#BlackFrame { line-height:19px; }');
				document.write('#WhiteFrame { line-height:19px; }');
				break;
			case "XL":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:26px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:26px; }');
				document.write('.ham_eval { font-size:15px; line-height:18px; padding: 6px 0px 0px 6px; }');
				document.write('.x_char { font-size:19px; }');
				document.write('.y_char { font-size:19px; }');
				document.write('#score_panel { font-size:18px; }');
				document.write('#y-coordinate { margin-top:11px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:6px; }');
				document.write('#PutCheck { top:4px; }');
				document.write('#KifuText { font-size:17px; }');
				document.write('#SetKifu { top:5px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				break;
			case "EL":
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:32px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:32px; }');
				document.write('.ham_eval { font-size:16px; line-height:21px; padding: 7px 0px 0px 8px; }');
				document.write('.x_char { font-size:20px; }');
				document.write('.y_char { font-size:20px; }');
				document.write('#score_panel { font-size:20px; }');
				document.write('#y-coordinate { margin-top:13px; }');
				document.write('#NextMove { top:5px; }');
				document.write('#PutTrial { top:8px; }');
				document.write('#PutCheck { top:4px; }');
				document.write('#KifuText { font-size:17px; }');
				document.write('#SetKifu { top: 4px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				break;
			default:
				document.write('.ham_face { padding: 1px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_back { padding: 2px 0px 0px 1px; line-height:18px; }');
				document.write('.ham_eval { font-size:9px; line-height:14px; padding: 4px 0px 0px 1px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#score_panel { font-size:14px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { left:79px; }');
				document.write('#PutTrial { top:7px; }');
				document.write('#KifuText { font-size:14px; }');
				document.write('#SetKifu { top:3px; }');
				document.write('#BlackFrame { line-height:17px; }');
				document.write('#WhiteFrame { line-height:17px; }');
		}
		document.write('</style>');
		break;
	default:
		;	
	}
}

function iPhone_browser()
{
	switch (checkBrowserName()) {
	case "IPHONE":
		document.write('<style type="text/css">');
		document.write('.ham_face { vertical-align: baseline; }');
		document.write('.ham_back { vertical-align: baseline; }');
		switch (strSize.toUpperCase()) {
			case "SS":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { line-height:15px; }');
				document.write('.ham_back { line-height:15px; }');
				document.write('.ham_eval { font-size:8px; line-height:11px; padding: 4px 0px 0px 3px; }');
				document.write('.x_char { font-size:12px; }');
				document.write('.y_char { font-size:12px; }');
				document.write('#BlackFrame { line-height:15px; }');
				document.write('#WhiteFrame { line-height:15px; }');
				document.write('#score_panel { font-size:12px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:5px; line-height:11px; }');
				document.write('#PutTrial { top:6px; }');
				document.write('#PutCheck { top:3px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { font-size:8px; }');
				document.write('#first {	font-size:10px; }');
				document.write('#prev  {	font-size:10px; }');
				document.write('#kifu  {	font-size:10px; }');
				document.write('#next  {	font-size:10px; }');
				document.write('#last  {	font-size:10px; }');
				break;
			case "S":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { line-height:17px; }');
				document.write('.ham_back { line-height:17px; }');
				document.write('.ham_eval { font-size:9px; line-height:12px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#BlackFrame { line-height:17px; }');
				document.write('#WhiteFrame { line-height:17px; }');
				document.write('#score_panel { font-size:13px; }');
				document.write('#y-coordinate { margin-top:3px; }');
				document.write('#NextMove { top:6px; line-height:14px; }');
				document.write('#PutCheck { top:4px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { font-size:9px; }');
				document.write('#first {	font-size:11px; }');
				document.write('#prev  {	font-size:11px; }');
				document.write('#kifu  {	font-size:11px; }');
				document.write('#next  {	font-size:11px; }');
				document.write('#last  {	font-size:11px; }');
				break;
			case "M":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:19px; line-height:19px; }');
				document.write('.ham_back { font-size:19px; line-height:19px; }');
				document.write('.ham_eval { font-size:11px; line-height:13px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:15px; }');
				document.write('.y_char { font-size:15px; }');
				document.write('#BlackFrame { line-height:18px; }');
				document.write('#WhiteFrame { line-height:18px; }');
				document.write('#score_panel { font-size:14px; }');
				document.write('#y-coordinate { margin-top:4px; }');
				document.write('#NextMove { top:5px; line-height:17px; }');
				document.write('#PutCheck { top:6px; }');
				document.write('#KifuText { font-size:14px; }');
				document.write('#SetKifu { font-size:10px; }');
				document.write('#first {	font-size:12px; }');
				document.write('#prev  {	font-size:12px; }');
				document.write('#kifu  {	font-size:12px; }');
				document.write('#next  {	font-size:12px; }');
				document.write('#last  {	font-size:12px; }');
				break;
			case "L":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:23px; line-height:23px; }');
				document.write('.ham_back { font-size:23px; line-height:23px; }');
				document.write('.ham_eval { font-size:13px; line-height:15px; padding: 6px 0px 0px 3px; }');
				document.write('.x_char { font-size:17px; }');
				document.write('.y_char { font-size:17px; }');
				document.write('#BlackFrame { line-height:18px; }');
				document.write('#WhiteFrame { line-height:18px; }');
				document.write('#score_panel { font-size:16px; }');
				document.write('#y-coordinate { margin-top:5px; }');
				document.write('#NextMove { top:5px; line-height:15px; }');
				document.write('#PutCheck { top:5px; }');
				document.write('#KifuText { font-size:15px; }');
				document.write('#SetKifu { font-size:11px; }');
				document.write('#first {	font-size:13px; }');
				document.write('#prev  {	font-size:13px; }');
				document.write('#kifu  {	font-size:14px; }');
				document.write('#next  {	font-size:13px; }');
				document.write('#last  {	font-size:13px; }');
				break;
			case "XL":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:27px; line-height:27px; }');
				document.write('.ham_back { font-size:27px; line-height:27px; }');
				document.write('.ham_eval { font-size:15px; line-height:17px; padding: 6px 0px 0px 6px; }');
				document.write('.x_char { font-size:19px; }');
				document.write('.y_char { font-size:19px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				document.write('#score_panel { font-size:18px; }');
				document.write('#y-coordinate { margin-top:9px; }');
				document.write('#NextMove { top:5px; line-height:17px; }');
				document.write('#PutCheck { top:5px; }');
				document.write('#KifuText { font-size:16px; }');
				document.write('#SetKifu { font-size:12px; }');
				document.write('#first {	font-size:15px; }');
				document.write('#prev  {	font-size:15px; }');
				document.write('#kifu  {	font-size:15px; }');
				document.write('#next  {	font-size:15px; }');
				document.write('#last  {	font-size:15px; }');
				break;
			case "EL":
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { font-size:32px; line-height:32px; }');
				document.write('.ham_back { font-size:32px; line-height:32px; }');
				document.write('.ham_eval { font-size:16px; line-height:20px; padding: 7px 0px 0px 8px; }');
				document.write('.x_char { font-size:20px; }');
				document.write('.y_char { font-size:20px; }');
				document.write('#BlackFrame { line-height:21px; }');
				document.write('#WhiteFrame { line-height:21px; }');
				document.write('#score_panel { font-size:20px; }');
				document.write('#y-coordinate { margin-top:11px; }');
				document.write('#NextMove { top:5px; line-height:16px; }');
				document.write('#KifuText { font-size:17px; }');
				document.write('#PutCheck { top:4px; }');
				document.write('#SetKifu { font-size:13px; }');
				document.write('#first {	font-size:17px; }');
				document.write('#prev  {	font-size:17px; }');
				document.write('#kifu  {	font-size:17px; }');
				document.write('#next  {	font-size:17px; }');
				document.write('#last  {	font-size:17px; }');
				break;
			default:
				document.write('.ham_face { padding: 1px 0px 0px 2px; }');
				document.write('.ham_back { padding: 2px 0px 0px 2px; }');
				document.write('.ham_face { line-height:17px; }');
				document.write('.ham_back { line-height:17px; }');
				document.write('.ham_eval { font-size:9px; line-height:12px; padding: 4px 0px 0px 2px; }');
				document.write('.x_char { font-size:14px; }');
				document.write('.y_char { font-size:14px; }');
				document.write('#BlackFrame { line-height:17px; }');
				document.write('#WhiteFrame { line-height:17px; }');
				document.write('#score_panel { font-size:13px; }');
				document.write('#y-coordinate { margin-top:3px; }');
				document.write('#NextMove { top:5px; line-height:13px; }');
				document.write('#KifuText { font-size:13px; }');
				document.write('#SetKifu { font-size:9px; }');
				document.write('#first {	font-size:11px; }');
				document.write('#prev  {	font-size:11px; }');
				document.write('#kifu  {	font-size:11px; }');
				document.write('#next  {	font-size:11px; }');
				document.write('#last  {	font-size:11px; }');
		}
		document.write('</style>');
		break;
	default:
		;	
	}
}